Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/config/axis_attribute.conf
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/config/axis_attribute.conf	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/config/axis_attribute.conf	(revision 1930)
@@ -22,21 +22,21 @@
 
 /* LOCAL */
-DECLARE_ARRAY(double , 1   , value)
-DECLARE_ATTRIBUTE(StdString, axis_ref)
+DECLARE_ARRAY(double , 1   , value, false)
+DECLARE_ATTRIBUTE(StdString, axis_ref, false)
 
-DECLARE_ARRAY(int    ,1    , index)
+DECLARE_ARRAY(int    ,1    , index, false)
 
 /* LOCAL */
-DECLARE_ATTRIBUTE(int,       data_n)
-DECLARE_ATTRIBUTE(int,       data_begin)
-DECLARE_ARRAY(int    ,   1 , data_index)
+DECLARE_ATTRIBUTE(int,       data_n, false)
+DECLARE_ATTRIBUTE(int,       data_begin, false)
+DECLARE_ARRAY(int    ,   1 , data_index, false)
 
 /*LOCAL */
-DECLARE_ATTRIBUTE(int,       begin)
-DECLARE_ATTRIBUTE(int,       n)
+DECLARE_ATTRIBUTE(int,       begin, false)
+DECLARE_ATTRIBUTE(int,       n, false)
 
 /* LOCAL */
-DECLARE_ARRAY(bool, 1 , mask)
-DECLARE_ARRAY(double, 2 , bounds)
+DECLARE_ARRAY(bool, 1 , mask, false)
+DECLARE_ARRAY(double, 2 , bounds, false)
 DECLARE_ATTRIBUTE(int,       prec)
-DECLARE_ARRAY(StdString    ,1    , label)
+DECLARE_ARRAY(StdString    ,1    , label, false)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/config/domain_attribute.conf
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/config/domain_attribute.conf	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/config/domain_attribute.conf	(revision 1930)
@@ -57,8 +57,8 @@
 DECLARE_ARRAY(double, 3, bounds_lat_2d, false)
 
-DECLARE_ARRAY(double, 2, area)
+DECLARE_ARRAY(double, 2, area, false)
 DECLARE_ATTRIBUTE(double, radius)
 
 DECLARE_ENUM4(type,rectilinear,curvilinear,unstructured, gaussian)
-DECLARE_ATTRIBUTE(StdString, domain_ref)
+DECLARE_ATTRIBUTE(StdString, domain_ref, false)
 DECLARE_ATTRIBUTE(int,       prec)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/data_input.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/data_input.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/data_input.cpp	(revision 1930)
@@ -19,7 +19,7 @@
   //----------------------------------------------------------------
 
-  void CDataInput::readFieldData(CField* field, CArray<double,1>& data)
+  void CDataInput::readFieldData(CField* field, int record, CArray<double,1>& data)
   {
-    this->readFieldData_(field,data);
+    this->readFieldData_(field, record, data);
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/data_input.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/data_input.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/data_input.hpp	(revision 1930)
@@ -18,5 +18,5 @@
       /// Read methods ///
       StdSize getFieldNbRecords(CField* field);
-      void readFieldData(CField* field, CArray<double,1>& data);
+      void readFieldData(CField* field, int record, CArray<double,1>& data);
       void readFieldAttributesMetaData(CField* field);
       void readFieldAttributesValues(CField* field);
@@ -27,5 +27,5 @@
     protected:
       virtual StdSize getFieldNbRecords_(CField* field) = 0;
-      virtual void readFieldData_(CField* field, CArray<double,1>& data) = 0;
+      virtual void readFieldData_(CField* field, int record, CArray<double,1>& data) = 0;
       virtual void readFieldAttributes_(CField* field, bool readAttributeValues) = 0;
       virtual void closeFile_(void) = 0;
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distributed_view.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distributed_view.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distributed_view.cpp	(revision 1930)
@@ -9,5 +9,5 @@
                                     : globalIndex_(parent->globalIndex_), globalSize_(parent->globalSize_), localSize_(parent->localSize_) 
   {
-    for(auto index : indexView) 
+    for(auto& index : indexView) 
     {
       index_[index.first].reference(index.second.copy()) ;
@@ -16,4 +16,20 @@
   }
 
-
-} 
+  CDistributedView::CDistributedView(CDistributedElement* parent, CElementView::type, const std::map<int,CArray<bool,1>>& maskView) 
+                                    : globalIndex_(parent->globalIndex_), globalSize_(parent->globalSize_), localSize_(parent->localSize_) 
+  {
+    for(auto& it : maskView) 
+    {
+      int rank = it.first ;
+      auto& mask = it.second ;
+      int size = mask.numElements() ;
+      auto& index = index_[rank] ; 
+      index.resize(size) ;
+      int pos=0 ;
+      for(int i=0 ; i < size ; i++)
+        if (mask(i)) { index(pos) = i ; pos++ ; }
+      index.resizeAndPreserve(pos) ;
+      size_[rank] = pos ;
+    }
+  } 
+}
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distributed_view.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distributed_view.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distributed_view.hpp	(revision 1930)
@@ -15,4 +15,5 @@
 
       CDistributedView(CDistributedElement* parent, CElementView::type type, const std::map<int,CArray<int,1>>& indexView) ;
+      CDistributedView(CDistributedElement* parent, CElementView::type type, const std::map<int,CArray<bool,1>>& maskView) ;
       
       std::map<int,CArray<int,1>>&  getIndex(void) { return index_ ;}
@@ -21,4 +22,28 @@
       std::map<int, int>& getLocalSize(void) { return localSize_ ;}
       size_t getGlobalSize(void) { return globalSize_ ;}
+
+      void getGlobalIndexView(map<int,CArray<size_t,1>>& globalIndexView)
+      {
+        for(auto& it : globalIndex_)
+        {
+          int rank=it.first ;
+          auto& globalIndex = it.second;
+          auto& globalIndView = globalIndexView[rank] ;
+          auto& index = index_[rank] ;
+          auto& size = size_[rank] ;
+          auto& localSize = localSize_[rank] ;
+          globalIndView.resize(size) ;
+          int pos=0 ;
+          for(int i=0 ; i<size ; i++)
+          {
+            if (index(i)>=0 && index(i)<localSize) 
+            {
+              globalIndView(i) = globalIndex(index(i)) ;
+              pos++ ;
+            }
+          }
+          globalIndView.resizeAndPreserve(pos) ;
+      }
+    }   
 
       void getGlobalIndex(int rank, vector<size_t>& globalIndex, size_t sliceIndex, size_t* sliceSize, CDistributedView** view, int pos)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distribution_type.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distribution_type.hpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/distribution_type.hpp	(revision 1930)
@@ -0,0 +1,9 @@
+#ifndef __DISTRIBUTION_TYPE_HPP__
+#define __DISTRIBUTION_TYPE_HPP__
+
+namespace xios
+{
+  enum class EDistributionType  { NONE=0, ROOT, BANDS, BLOCKS} ;
+}
+
+#endif
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/element.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/element.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/element.cpp	(revision 1930)
@@ -29,4 +29,9 @@
   {
     views_[type] = new CDistributedView(this, type, indexView) ;
+  } 
+
+  void CDistributedElement::addView(CElementView::type type, std::map<int, CArray<bool,1>>& maskView)
+  {
+    views_[type] = new CDistributedView(this, type, maskView) ;
   } 
 
@@ -118,4 +123,9 @@
   } 
 
+  void CLocalElement::addView(CElementView::type type, CArray<bool,1>& maskView)
+  {
+    views_[type] = new CLocalView(this, type, maskView) ;
+  } 
+
   void CLocalElement::addFullView(void)
   {
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/element.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/element.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/element.hpp	(revision 1930)
@@ -40,4 +40,5 @@
 
     void addView(CElementView::type type, std::map<int, CArray<int,1>>& indexView) ;
+    void addView(CElementView::type type, std::map<int, CArray<bool,1>>& maskView) ;
     void sendToServer(CEventClient& event, const CMessage& messageHeader) ;
 
@@ -55,6 +56,7 @@
       CLocalElement(int localRank, CEventServer& event) ;
       void recvFromClient(int localRank, CEventServer& event) ;
-      
+      const CArray<size_t,1>& getGlobalIndex(void) { return globalIndex_ ;}
       void addView(CElementView::type type, CArray<int,1>& indexView) ;
+      void addView(CElementView::type type, CArray<bool,1>& maskView) ;
       void addFullView(void) ;
       CLocalView* getView(CElementView::type type) 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.cpp	(revision 1930)
@@ -15,5 +15,7 @@
     unordered_map<size_t,int> mapGlobalLocalIndex ;
     int globalIndexSize=dstGlobalIndex.size() ;
-    for(auto& ind : dstIndex) mapGlobalLocalIndex[dstGlobalIndex(ind)] = ind ;
+    //for(auto& ind : dstIndex) mapGlobalLocalIndex[dstGlobalIndex(ind)] = ind ;
+    for(int i=0; i<dstSize_ ; i++) if (dstIndex(i)>=0 && dstIndex(i)<globalIndexSize) mapGlobalLocalIndex[dstGlobalIndex(dstIndex(i))] = i ;
+
     for(auto& rankIndex : srcIndex)
     {
@@ -27,7 +29,7 @@
       for(int ind=0; ind<indexSize ; ind++)
       {
-        if (ind>=0 && ind<globalIndexSize)
+        if (index(ind)>=0 && index(ind)<globalIndexSize)
         {
-           auto it=mapGlobalLocalIndex.find(globalIndex(ind)) ;
+           auto it=mapGlobalLocalIndex.find(globalIndex(index(ind))) ;
            if (it != mapGlobalLocalIndex.end()) 
            {
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.hpp	(revision 1930)
@@ -29,7 +29,8 @@
       
       template<typename T>
-      void transfer(map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut)
+      void transfer(int sizeT, map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut)
       {
-        dataOut.resize(dstSize_) ;
+        // for future, make a specific transfer function for sizeT=1 to avoid multiplication (increasing performance)
+        dataOut.resize(dstSize_*sizeT) ;  
         T* output = dataOut.dataFirst() ;
         for(auto& data : dataIn)
@@ -39,5 +40,5 @@
           auto& connector=connector_[rank] ;
           auto& mask=mask_[rank] ;
-          int size=data.second.numElements() ;
+          int size=mask.size() ;
 
           for(int i=0, j=0 ;i<size;i++)
@@ -45,5 +46,7 @@
             if (mask[i]) 
             {
-              output[connector[j]] = input[i] ;
+              int cj = connector[j]*sizeT ;
+              int ci = i*sizeT ;
+              for (int k=0;k<sizeT;k++) output[cj+k] = input[ci+k] ;
               j++ ;
             }
@@ -52,4 +55,9 @@
       }
     
+      template<typename T>
+      void transfer(map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut)
+      {
+        transfer(1,dataIn,dataOut) ;
+      }
 
       template<typename T>
@@ -93,11 +101,17 @@
       void transfer(map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut, T missingValue)
       {
-        dataOut.resize(dstSize_) ;
-        dataOut=missingValue ;
-        transfer(map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut) ;
+        transfer(1, dataIn, dataout, missingValue)
       }
       
       template<typename T>
-      void transfer(CEventServer& event, CArray<T,1>& dataOut)
+      void transfer(int sizeT, map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut, T missingValue)
+      {
+        dataOut.resize(dstSize_*sizeT) ;
+        dataOut=missingValue ;
+        transfer(sizeT, dataIn, dataOut) ;
+      }
+
+      template<typename T>
+      void transfer(CEventServer& event, int sizeT, CArray<T,1>& dataOut)
       {
         map<int, CArray<T,1>> dataIn ;
@@ -107,5 +121,23 @@
           (*subEvent.buffer) >> data ;
         }
-        transfer(dataIn, dataOut) ;
+        transfer(sizeT, dataIn, dataOut) ;
+      }
+      
+      template<typename T>
+      void transfer(CEventServer& event, CArray<T,1>& dataOut)
+      {
+        transfer(event, 1, dataOut) ;
+      }
+
+      template<typename T>
+      void transfer(CEventServer& event, int sizeT, CArray<T,1>& dataOut, T missingValue)
+      {
+        map<int, CArray<T,1>> dataIn ;
+        for (auto& subEvent : event.subEvents) 
+        {
+          auto& data = dataIn[subEvent.rank]; 
+          (*subEvent.buffer) >> data ;
+        }
+        transfer(sizeT, dataIn, dataOut, missingValue) ;
       }
 
@@ -119,5 +151,5 @@
           (*subEvent.buffer) >> data ;
         }
-        transfer(dataIn, dataOut, missingValue) ;
+        transfer(1, dataIn, dataOut, missingValue) ;
       }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_view.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_view.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_view.cpp	(revision 1930)
@@ -6,5 +6,11 @@
   CGridLocalView::CGridLocalView(CGridLocalElements* parent, CElementView::type type) : localMask_(parent->getLocalMask())
   {
-    for(auto element : parent->getElements()) views_.push_back(element->getView(type)) ;
+    size_ = 1 ;
+    for(auto element : parent->getElements()) 
+    {
+      views_.push_back(element->getView(type)) ;
+      size_ *= element->getView(type)->getSize() ;
+    }
+
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_view.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_view.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_view.hpp	(revision 1930)
@@ -14,8 +14,10 @@
       std::vector<CLocalView*> views_ ;
       std::vector<bool>& localMask_ ;
+      int size_ ;
     
     public:
       CGridLocalView(CGridLocalElements* parent, CElementView::type type) ;
       std::vector<CLocalView*>& getViews(void) {return views_ ;}
+      int getSize() { return size_ ;}
   } ;
 }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_remote_connector.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_remote_connector.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_remote_connector.cpp	(revision 1930)
@@ -19,4 +19,60 @@
   {
     // generic method, every element can be distributed
+    int nDst = dstView_.size() ;
+    vector<size_t> dstSliceSize(nDst) ;
+    dstSliceSize[0] = 1 ;  
+    for(int i=1; i<nDst; i++)  dstSliceSize[i] = dstView_[i-1]->getGlobalSize()*dstSliceSize[i-1] ;
+  
+    CClientClientDHTTemplate<int>::Index2VectorInfoTypeMap dataInfo ;
+
+    CClientClientDHTTemplate<size_t>::Index2VectorInfoTypeMap info ; // info map
+    for(int pos=0; pos<nDst; pos++)
+    {
+      size_t sliceSize=dstSliceSize[pos] ;
+      map<int,CArray<size_t,1>> globalIndexView ;
+      dstView_[pos]->getGlobalIndexView(globalIndexView) ;
+      
+      CClientClientDHTTemplate<size_t>::Index2VectorInfoTypeMap lastInfo(info) ;
+
+      if (pos>0)
+      {
+        CArray<size_t,1> ranks(globalIndexView.size()) ;
+        auto it=globalIndexView.begin() ;
+        for(int i=0 ; i<ranks.numElements();i++,it++) ranks(i)=it->first ;
+        CClientClientDHTTemplate<size_t> dataRanks(info, localComm_) ;
+        dataRanks.computeIndexInfoMapping(ranks) ;
+        lastInfo = dataRanks.getInfoIndexMap() ;
+      }
+      
+      info.clear() ;
+      for(auto& it : globalIndexView)
+      {
+        int rank = it.first ;
+        auto& globalIndex = it.second ;
+        auto& inf = info[rank] ;
+        if (pos==0) for(int i=0;i<globalIndex.numElements();i++) inf.push_back(globalIndex(i)) ;
+        else
+        {
+          auto& lastGlobalIndex = lastInfo[rank] ;
+          for(size_t lastGlobalInd : lastGlobalIndex)
+          {
+            for(int i=0;i<globalIndex.numElements();i++) inf.push_back(globalIndex(i)*sliceSize+lastGlobalInd) ;
+          }
+        } 
+      }
+
+      if (pos==nDst-1)
+      {
+         for(auto& it : info)
+         {
+           int rank=it.first ;
+           auto& globalIndex = it.second ;
+           for(auto globalInd : globalIndex) dataInfo[globalInd].push_back(rank) ;
+         }
+      } 
+    }
+
+    CClientClientDHTTemplate<int> dataRanks(dataInfo, localComm_) ;
+/*
     CClientClientDHTTemplate<int>::Index2VectorInfoTypeMap info ; // info map
         
@@ -37,11 +93,14 @@
     
     CClientClientDHTTemplate<int> dataRanks(info, localComm_) ;
-    
+*/    
     // generate list of global index for src view
     int nSrc = srcView_.size() ;
     vector<size_t> srcSliceSize(nSrc) ;
-    srcSliceSize[nSrc-1] = 1 ;
-    for(int i=nSrc-2; i>=0; i--)  srcSliceSize[i] = srcView_[i+1]->getGlobalSize()*srcSliceSize[i+1] ;
-    
+//    srcSliceSize[nSrc-1] = 1 ;
+//    for(int i=nSrc-2; i>=0; i--)  srcSliceSize[i] = srcView_[i+1]->getGlobalSize()*srcSliceSize[i+1] ;
+   
+    srcSliceSize[0] = 1 ;  
+    for(int i=1; i<nSrc; i++)  srcSliceSize[i] = srcView_[i-1]->getGlobalSize()*srcSliceSize[i-1] ;
+
     vector<size_t> srcGlobalIndex ;
     size_t sliceIndex=0 ;
@@ -54,6 +113,6 @@
     vector<map<int, set<size_t>>> elements(nSrc) ; // internal representation of elements composing the grid
 
-    srcSliceSize[nSrc-1] = srcView_[nSrc-1]->getGlobalSize() ;
-    for(int i=nSrc-2 ; i>=0 ; i--) srcSliceSize[i] = srcView_[i]->getGlobalSize()*srcSliceSize[i+1] ;
+//    srcSliceSize[nSrc-1] = srcView_[nSrc-1]->getGlobalSize() ;
+//    for(int i=nSrc-2 ; i>=0 ; i--) srcSliceSize[i] = srcView_[i]->getGlobalSize()*srcSliceSize[i+1] ;
 
     for(auto& indRanks : returnInfo)
@@ -61,8 +120,9 @@
       size_t gridIndexGlo=indRanks.first ;
       auto& ranks = indRanks.second ;
-      for(int i=0;i<nSrc;i++)
+      for(int i=nSrc-1; i>=0; i--)
       {
         auto& element = elements[i] ;
-        size_t localIndGlo = gridIndexGlo % srcSliceSize[i] ;
+        size_t localIndGlo = gridIndexGlo / srcSliceSize[i] ;
+        gridIndexGlo = gridIndexGlo % srcSliceSize[i] ;
         for(int rank : ranks) element[rank].insert(localIndGlo) ;
       }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/local_view.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/local_view.cpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/local_view.cpp	(revision 1930)
@@ -15,4 +15,12 @@
   }
 
+  CLocalView::CLocalView(CLocalElement* parent, CElementView::type type, const CArray<bool,1>& maskView) 
+                        : CDistributedView( parent, type, {{  parent->localRank_,  maskView }} ),
+                          localRank_(parent->localRank_),
+                          globalIndex_(parent->globalIndex_), size_(CDistributedView::size_[parent->localRank_]),
+                          index_(CDistributedView::index_[parent->localRank_]), localSize_(CDistributedView::localSize_[parent->localRank_]) 
+  {
+
+  }
 
   void CLocalView::sendRemoteElement(CRemoteConnector& connector, CContextClient* client, CEventClient& event, const CMessage& messageHeader)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/local_view.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/local_view.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/local_view.hpp	(revision 1930)
@@ -17,6 +17,23 @@
     public:
     CLocalView(CLocalElement* parent, CElementView::type type, const CArray<int,1>& indexView) ;
+    CLocalView(CLocalElement* parent, CElementView::type type, const CArray<bool,1>& maskView) ;
+
     const CArray<int,1>& getIndex(void) { return index_ ;}
     const CArray<size_t,1>& getGlobalIndex(void) { return globalIndex_ ;}
+    
+    void getGlobalIndexView(CArray<size_t,1>& globalIndexView)
+    {
+      globalIndexView.resize(size_) ;
+      int pos=0 ;
+      for(int i=0 ; i<size_ ; i++)
+      {
+        if (index_(i)>=0 && index_(i)<localSize_) 
+        {
+          globalIndexView(i) = globalIndex_(index_(i)) ;
+          pos++ ;
+        }
+      }
+      globalIndexView.resizeAndPreserve(pos) ;
+    }    
 
     void getGlobalIndex(vector<size_t>& globalIndex, size_t sliceIndex, size_t* sliceSize, CLocalView** localView, int pos)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/scatterer_connector.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/scatterer_connector.hpp	(revision 1929)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/scatterer_connector.hpp	(revision 1930)
@@ -34,7 +34,20 @@
     void computeConnector(void) ;
     
-    template<typename T>
-    void transfer(const CArray<T,1>& dataIn, map<int, CArray<T,1>>& dataOut)
+    template<typename T, int n>
+    void transfer(const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut)
     {
+      transfer(1, dataIn, dataOut) ;
+    }
+
+    template<typename T, int n>
+    void transfer(const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut, T missingValue)
+    {
+      transfer(1, dataIn, dataOut, missingValue) ;
+    }
+
+    template<typename T, int n>
+    void transfer(int sizeT, const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut)
+    {
+      // for future, make a specific transfer function for sizeT=1 to avoid multiplication (increasing performance)
       for(auto& rankConnector : connector_)
       {
@@ -44,5 +57,5 @@
         int dstSize = mask.size() ;
         auto& data = dataOut[rank] ;
-        data.resize(dstSize) ;
+        data.resize(dstSize * sizeT) ;
         T* dstData = data.dataFirst() ;
         const T* srcData = dataIn.dataFirst() ;
@@ -50,5 +63,33 @@
           if (mask[i]) 
           {
-            dstData[i] = srcData[connector[j]] ;
+            for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = srcData[connector[j]*sizeT+k] ;
+            j++ ;
+          }
+      }
+    }
+
+    template<typename T, int n>
+    void transfer(int sizeT, const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut, T missingValue)
+    {
+      // for future, make a specific transfer function for sizeT=1 to avoid multiplication (increasing performance)
+      for(auto& rankConnector : connector_)
+      {
+        int rank = rankConnector.first ;
+        auto& connector = rankConnector.second ;
+        auto& mask = mask_[rank] ;
+        int dstSize = mask.size() ;
+        auto& data = dataOut[rank] ;
+        data.resize(dstSize * sizeT) ;
+        T* dstData = data.dataFirst() ;
+        const T* srcData = dataIn.dataFirst() ;
+        for(int i=0, j=0; i<dstSize; i++)
+          if (mask[i]) 
+          {
+            for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = srcData[connector[j]*sizeT+k] ;
+            j++ ;
+          }
+          else 
+          {
+            for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = missingValue ;
             j++ ;
           }
@@ -56,9 +97,29 @@
     }
     
-    template<typename T>
-    void transfer(const CArray<T,1>& dataIn, CContextClient* client, CEventClient& event, const CMessage& messageHeader)
+    template<typename T,int n>
+    void transfer(const CArray<T,n>& dataIn, CContextClient* client, CEventClient& event, const CMessage& messageHeader)
+    {
+      transfer(1, dataIn, client, event, messageHeader) ;
+    }
+
+    template<typename T,int n>
+    void transfer(const CArray<T,n>& dataIn, T missingValue, CContextClient* client, CEventClient& event, const CMessage& messageHeader)
+    {
+      transfer(1, dataIn, missingValue, client, event, messageHeader) ;
+    }
+
+    template<typename T, int n>
+    void transfer(int sizeT, const CArray<T,n>& dataIn, CContextClient* client, CEventClient& event, const CMessage& messageHeader)
     {
       map<int, CArray<T,1>> dataOut ;
-      transfer(dataIn, dataOut) ;
+      transfer(sizeT, dataIn, dataOut) ;
+      sendToServer(dataOut, client, event, messageHeader) ;
+    }
+
+    template<typename T, int n>
+    void transfer(int sizeT, const CArray<T,n>& dataIn, T missingValue, CContextClient* client, CEventClient& event, const CMessage& messageHeader)
+    {
+      map<int, CArray<T,1>> dataOut ;
+      transfer(sizeT, dataIn, dataOut, missingValue) ;
       sendToServer(dataOut, client, event, messageHeader) ;
     }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_client_source_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_client_source_filter.cpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_client_source_filter.cpp	(revision 1930)
@@ -0,0 +1,51 @@
+#include "source_filter.hpp"
+#include "grid.hpp"
+#include "exception.hpp"
+#include "calendar_util.hpp"
+#include "field.hpp"
+#include "context.hpp"
+#include "grid.hpp"
+#include <limits> 
+
+namespace xios
+{
+    CClientFromClientSourceFilter::CClientFromClientSourceFilter(CGarbageCollector& gc, CField* field)
+     : COutputPin(gc, true)
+    {
+      CContext* context = CContext::getCurrent();
+      grid_= field-> getGrid();
+
+      freqOp_ = field->freq_op ;
+      lastDateReceived_ = context->getCalendar()->getInitDate();
+      offset_ = field->freq_offset ;
+    }
+
+  void CClientFromClientSourceFilter::streamData(CEventServer& event)
+  {
+    // unlikely to input from file server where data are received at ts=0
+    // for coupling, it would be after the first freq_op, because for now we don't have
+    // restart mecanism to send the value at ts=0. It must be changed in future
+  
+    if (wasDataAlreadyReceived_) lastDateReceived_ = lastDateReceived_ + freqOp_;
+    else wasDataAlreadyReceived_ = true ;
+
+    CDate date = lastDateReceived_ + offset_; // not sure is usefull check it for all filters
+
+    CDataPacketPtr packet(new CDataPacket);
+    packet->date = date;
+    packet->timestamp = date;
+    packet->status = CDataPacket::NO_ERROR;
+
+    grid_->getClientFromClientConnector()->transfer(event,packet->data) ;
+    onOutputReady(packet);
+  }
+
+  bool CClientFromClientSourceFilter::isDataLate(void)
+  {
+    bool isDataLate ;
+    CDate currentDate = CContext::getCurrent()->getCalendar()->getCurrentDate() ;
+    if (wasDataAlreadyReceived_) isDataLate = lastDateReceived_ + offset_ + freqOp_ <= currentDate ;
+    else isDataLate = CContext::getCurrent()->getCalendar()->getInitDate()+ offset_ <= currentDate ;
+  }
+
+} // namespace xios
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_client_source_filter.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_client_source_filter.hpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_client_source_filter.hpp	(revision 1930)
@@ -0,0 +1,48 @@
+#ifndef __XIOS_CLIENT_FROM_CLIENT_SOURCE_FILTER__
+#define __XIOS_CLIENT_FROM_CLIENT_SOURCE_FILTER__
+
+#include "output_pin.hpp"
+#include "event_server.hpp"
+#include "calendar_util.hpp"
+
+namespace xios
+{
+  class CField;
+  class CGrid ;
+
+
+  /*!
+   * A source filter is the entry point of the data in the graph of filters.
+   */
+  class CClientFromClientSourceFilter : public COutputPin
+  {
+    public:
+      /*!
+       * Constructs a source filter accepting data attached to the specified grid.
+       *
+       * \param gc the garbage collector associated with this filter
+       * \param field the field which the filter aply
+       */
+      CClientFromClientSourceFilter(CGarbageCollector& gc, CField* field) ;
+                    
+      /*!
+       * Transforms the data received from the model into a packet and send it
+       * in the filter graph. The array containing the data can safely be reused
+       * immediately after this method returns.
+       *
+       * \param event the event associated to data reception
+       */
+      void streamData(CEventServer& event);
+      bool isDataLate(void) ;
+
+    private:
+      CGrid* grid_;             //!< The grid attached to the data the filter can accept
+      CDuration freqOp_ ;
+      CDuration offset_ ;
+
+      bool wasDataAlreadyReceived_= false ;
+      CDate lastDateReceived_ ;
+  }; // class CSourceFilter
+} // namespace xios
+
+#endif //__XIOS_CLIENT_FROM_CLIENT_SOURCE_FILTER__
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_server_source_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_server_source_filter.cpp	(revision 1930)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_from_server_source_filter.cpp	(revision 1930)
@@ -0,0 +1,62 @@
+#include "client_from_server_source_filter.hpp"
+#include "grid.hpp"
+#include "field.hpp"
+#include "file.hpp"
+#include "exception.hpp"
+#include "calendar_util.hpp"
+#include "context.hpp"
+#include <limits> 
+
+namespace xios
+{
+  CClientFromServerSourceFilter::CClientFromServerSourceFilter(CGarbageCollector& gc, CField* field)
+    : COutputPin(gc, true)
+  {
+    CContext* context = CContext::getCurrent();
+    grid_= field->getGrid();
+    freqOp_ = field->fileIn_->output_freq ;
+    lastDateReceived_ = context->getCalendar()->getInitDate();
+    offset_ = field->freq_offset ;
+  }
+
+  void CClientFromServerSourceFilter::streamData(CEventServer& event)
+  {
+    const bool wasEOF = isEOF_;
+    int record ;
+    for (auto& subEvent : event.subEvents) (*subEvent.buffer) >> record  ;
+    isEOF_ = (record == int(-1));
+
+    
+    if (wasDataAlreadyReceived_) lastDateReceived_ = lastDateReceived_ + freqOp_ ;
+    else wasDataAlreadyReceived_ = true;
+    
+    CDataPacketPtr packet(new CDataPacket);
+    packet->date = lastDateReceived_ + offset_;
+    packet->timestamp = packet->date ;
+
+    if (isEOF_) 
+    {
+      if (!wasEOF) dateEOF_ = lastDateReceived_;
+      packet->status = CDataPacket::END_OF_STREAM;
+    }
+    else 
+    {
+      grid_->getServerFromClientConnector()->transfer(event, packet->data) ;
+      packet->status = CDataPacket::NO_ERROR;
+    }
+    onOutputReady(packet);
+
+  }
+ 
+  bool CClientFromServerSourceFilter::isDataLate(void)
+  {
+    bool isDataLate ;
+    CDate currentDate = CContext::getCurrent()->getCalendar()->getCurrentDate() ;
+
+    const CDate nextDataDue = wasDataAlreadyReceived_ ? (lastDateReceived_ + freqOp_) : CContext::getCurrent()->getCalendar()->getInitDate();
+    isDataLate = (nextDataDue <= currentDate);
+    
+    return isDataLate ; 
+    
+  }
+} // namespace xios
